APP_CONFIG.branded_name = 'NBI Backup';

$(document).ready(function() {


    var SERVER_URL = 'ssh://top.nbi.dk:22';

    var private_key = null;
    var public_key = null;
    var uploaded = false;
    var folders = null;
    var orig_path = null;
    var warned_orig_path_changed = false;

    var html = 
    '<input id="backup-uri" type="hidden" name="backup-uri" />' +
    '<input id="encryption-method" name="encryption-method" type="hidden" />' +
    '<div id="nbi-username-and-password">' +
    '    <div class="input-hint">Enter your login details for NBI</div>' +
    '    <div id="nbi-username-label" class="edit-dialog-label">Username</div>' +
    '    <input type="text" name="nbi-username" id="nbi-username" class="text ui-widget-content ui-corner-all" />' +
    '    <div id="nbi-password-label" class="edit-dialog-label">Password</div>' +
    '    <input type="password" name="nbi-password" id="nbi-password" class="text ui-widget-content ui-corner-all" />' +
    '    <div id="nbi-password-label" class="edit-dialog-label">&nbsp;</div>' +
    '    <a class="action-link text ui-widget-content ui-corner-all" style="" id="nbi-create-and-upload-key">Connect to NBI server</a>' +
    '</div>' +
    '<div id="nbi-path-area" style="display: none">' +
    '    <div id="nbi-path-label" class="edit-dialog-label">Destination folder</div>' +
    '    <input type="text" name="nbi-path" id="nbi-path" class="text ui-widget-content ui-corner-all" />' +
    '</div>' +
    '<div id="nbi-loader" class="dialog" title="Setting up connection">' +
    '    <div id="nbi-loader-text">Loading ...</div>' +
    '</div>'
    ;

    EDIT_BACKUP.fill_dict_map['nbi-username'] = false;
    EDIT_BACKUP.fill_dict_map['nbi-password'] = false;
    EDIT_BACKUP.fill_dict_map['nbi-path'] = false;
    EDIT_BACKUP.fill_dict_map['backup-uri'] = function(dict, key, el, cfgel) {
        var url =
            SERVER_URL + 
            '/' + $('#nbi-path').val() +
            '?auth-username=' + encodeURIComponent($('#nbi-username').val()) +
            '&ssh-key=' + encodeURIComponent(private_key);

        dict['Backup']['TargetURL'] = url;        
    };

    EDIT_BACKUP.fill_form_map['TargetURL'] = function(dict, key, val, cfgel) {
        var url = EDIT_URI.decode_uri(val);

        private_key = url['--ssh-key'] || null;
        $('#nbi-path').val(url['server-path'] || '');
        $('#nbi-username').val(url['--auth-username'] || '');
    };

    EDIT_BACKUP.validate_form_map['edit-tab-target'] = function(tabindex) {
        if (private_key == null || (EDIT_STATE.newBackup && !uploaded)) {
            if ($('#nbi-username').val().trim() == '') {
                    $('#edit-dialog').tabs( "option", "active", tabindex);                
                    $('#nbi-username').focus();
                    alert('You must enter your NBI username');
                    return false;
            }
            if ($('#nbi-password').val().trim() == '') {
                    $('#edit-dialog').tabs( "option", "active", tabindex);                
                    $('#nbi-password').focus();
                    alert('You must enter your NBI password');
                    return false;
            }

            $('#edit-dialog').tabs( "option", "active", tabindex);                
            generateKey();
            return false;
        } else {
            if (EDIT_STATE.newBackup && !uploaded) {
                $('#edit-dialog').tabs( "option", "active", tabindex);                
                uploadKey();
                return false;
            }

            if ($('#nbi-path').val().trim() == '') {
                $('#edit-dialog').tabs( "option", "active", tabindex);                
                $('#nbi-path').focus();
                alert('You must enter a path');
                return false;
            }

            if (EDIT_STATE.newBackup) {
                if (folders == null) {
                    $('#edit-dialog').tabs( "option", "active", tabindex);                
                    updateFolders();
                    return false;
                }

                for(var f in folders)
                    if (folders[f] == $('#nbi-path').val().trim()) {
                        $('#edit-dialog').tabs( "option", "active", tabindex);                
                        $('#nbi-path').focus();
                        alert('The folder "' + $('#nbi-path').val().trim() + '" already exists, please use another folder');
                        return false;
                    }
            } else {
                if (orig_path != null && $('#nbi-path').val().trim() != orig_path.trim()) {
                    if (!warned_orig_path_changed && !confirm("You have changed the server folder, are you sure this is what you want?"))
                    {
                            $('#edit-dialog').tabs( "option", "active", tabindex);                
                            $('#nbi-path').focus();
                            return false;
                    }

                    for(var f in folders)
                        if (folders[f] == $('#nbi-path').val().trim()) {
                            $('#edit-dialog').tabs( "option", "active", tabindex);                
                            $('#nbi-path').focus();
                            alert('The folder "' + $('#nbi-path').val().trim() + '" already exists, please use another folder');
                            return false;
                        }

                        warned_orig_path_changed = true;
                }
            }

            return true;
        }
    };

    $("#edit-dialog").on('dialogopen', function() {
        private_key = null;
        public_key = null;
        uploaded = false;
        folders = null;
        orig_path = null;
        warned_orig_path_changed = false;
    });

    $("#edit-dialog").on('setup-dialog', function() {
        $('#encryption-method').val('');

        //$('#nbi-username').val('testuser');
        //$('#nbi-password').val('testuser');

        if ($('#nbi-username').val() != '' && private_key != null && private_key.trim() != '') {
            $('#nbi-username-and-password').hide();
            $('#nbi-path-area').show();
            orig_path = $('#nbi-path').val();
        } else {
            $('#nbi-username-and-password').show();
            $('#nbi-path-area').hide();
        }
    });

    // Remove advanced options tab
    $('#edit-dialog').parent().find('ul[role=tablist]').find('li[aria-controls=edit-tab-options]').remove();
    $('#edit-tab-options').remove();

    // Remove all in the target area and put in our own stuff
    $('#edit-tab-target').empty();
    $('#edit-tab-target').append($(html));

    $('#nbi-username').watermark('Enter your NBI username');
    $('#nbi-password').watermark('Enter your NBI password');

    // Remove encryption
    $('#encryption-area').remove();

    // Refresh the tab logic
    $('#edit-dialog').tabs('widget').tabs('refresh');

    $('#nbi-loader').dialog({
        modal: true,
        autoOpen: false,
        closeOnEscape: false
    });

    var generateKey = function() {
        $('#nbi-loader').dialog('open');
        $('#nbi-loader-text').html('Generating key ...');

        APP_DATA.callServer({action: 'send-command', command: 'ssh-keygen', 'key-type': 'dsa'}, function(data) {
            private_key = data.Result['privkeyuri'];
            public_key = data.Result['pubkey'];
            uploadKey();
        },
        function(data, success, message) {
            alert('Failed to create key: ' + message);
            $('#nbi-loader').dialog('close');
        });
    };

    var uploadKey = function() {
        $('#nbi-loader').dialog('open');
        $('#nbi-loader-text').html('Uploading key ...');

        var url =
            SERVER_URL + 
            '?auth-username=' + encodeURIComponent($('#nbi-username').val()) +
            '&auth-password=' + encodeURIComponent($('#nbi-password').val());


        APP_DATA.callServer({action: 'send-command', command: 'ssh-keyupload', HTTP_METHOD: 'POST', 'ssh-url': url, 'ssh-pubkey': public_key }, function(data) {
            uploaded = true;

            updateFolders();
        },
        function(data, success, message) {
            alert('Failed to upload key: ' + message);
            $('#nbi-loader').dialog('close');
        });
    };

    var updateFolders = function() {
        $('#nbi-loader').dialog('open');
        $('#nbi-loader-text').html('Listing folders ...');

        var url =
            SERVER_URL + 
            '?auth-username=' + encodeURIComponent($('#nbi-username').val()) +
            '&ssh-key=' + encodeURIComponent(private_key);

        APP_DATA.callServer({action: 'list-remote-folder', HTTP_METHOD: 'POST', 'url': url }, function(data) {
            folders = [];

            for(var i in data.Folders)
                if (data.Folders[i].IsFolder)
                    folders.push(data.Folders[i].Name);

            $('#nbi-username-and-password').hide();
            $('#nbi-path-area').show();

            $('#nbi-loader').dialog('close');
            $('#nbi-path').focus();
        },
        function(data, success, message) {
            alert('Failed to connect: ' + message);
            $('#nbi-loader').dialog('close');
        });
    };

    $('#nbi-loader').parent().find('.ui-dialog-titlebar-close').remove().first().remove();

    $('#nbi-create-and-upload-key').click(function() {
        if (private_key == null) {
            generateKey();
        } else {
            uploadKey();
        }
    });

    $('#restore-hint-donate').remove();
    $('#restore-hint-paypal').remove();
    $('#restore-hint-bitcoin').remove();
});